/*
 * Copyright (C) 1990 Democracy News Propaganda System.
 * Version 1.00
 * Produced By TheDog
 * All Rights Reserved
 *
 * This program can read a chinese article,
 * Provided by the Society of HKU Postgraduates on the Chinese Affairs,
 * on a ASCII terminal.
 *
 * July 2, 1990.
 *
 */
#include <stdio.h>
#include <stdio.h>

#define	ZITAPE	"chinese.16"
#define HEIGHT	16

char	filename[100];
char	dictname[100];
char	buffer[16][200];
FILE	*fp;
char	inbuf[512];
FILE	*bitmap;
char	charinline;

main (argc,argv)
int	argc;
char	**argv;
{
char	ch;
unsigned char	ch1,ch2;
int	charno;
char	charcnt;

	*filename=0;
	*dictname=0;
	charinline=5;
	while (--argc)
	{
		if ((*++argv)[0] == '-')
			switch ((*argv)[1])
			{
			 case 'w':
				charinline=atoi (*argv+2);
				break;
			 case 'd':
				strcpy (dictname,*argv+2);
				break;
			}
		else
			strcpy (filename,*argv);
	}
	if (*filename==0)
	{
		printf ("\7No file given\n");
		exit ();
	}
	if (*dictname==0)
		strcpy (dictname,ZITAPE);
	if ((fp=fopen(filename,"rb"))==NULL)
	{
		printf ("\7Can't open file - %s\n",filename);
		exit ();
	}

	charcnt=0;
	while ((ch=fgetc (fp))!=EOF)
	{
		ch1 = ch;
		if (ch1==13 || ch1==26)
		{
			if (charcnt>0)
			{
				putline (charcnt);
				charcnt=0;
			}
		}
		else if (ch1>=0x81)
		{
			if ((ch=fgetc (fp))==EOF)
			{
				printf ("\7File read error!\n");
				exit ();
			}
			ch2=ch;
			getbitmap (order(ch1,ch2));
			putbitmap (charcnt);
			charcnt++;
		}
		else
			if (map (ch,&ch1,&ch2) == 0)
			{
				getbitmap (order(ch1,ch2));
				putbitmap (charcnt);
				charcnt++;
			}
		if (charcnt==charinline)
		{
			putline (charinline);
			charcnt=0;
		}
	}
}

order (fontid,glyphid)
unsigned char	fontid,glyphid;
{
int	charno;
	if (fontid<0xA4)
	{
		if (glyphid<0x7F)
			charno=(fontid-0xA1)*157+(glyphid-0x40);
		else
			charno=(fontid-0xA1)*157+(glyphid-0xA1)+(0x7E-0x40+1);
	}
	else
	{
		if (glyphid<0x7F)
			charno=(fontid-0xA4)*157+(glyphid-0x40);
		else
			charno=(fontid-0xA4)*157+(glyphid-0xA1)+(0x7E-0x40+1);
		charno += 765;
	}
	return (charno);
}



getbitmap (glyphid)
int	glyphid;
{
long	absaddr;
int	i;
int	ch, tch;

	absaddr = (long)glyphid*32;
	absaddr += 256;

#ifdef unix
        bitmap = fopen (dictname, "r");
#else
	bitmap = fopen (dictname, "rb");
#endif
	fseek (bitmap, absaddr, 0);
	for (i=0; i<32; i++)
		fscanf (bitmap,"%c",&inbuf[i]);
	fclose (bitmap);
}

putbitmap (charpos)
char	charpos;
{
int	i,k;

	k=charpos*2;
	for (i=0; i<HEIGHT; i++)
	{
		buffer[i][k] = inbuf[i*2];
		buffer[i][k+1] = inbuf[i*2+1];
	}
}

putline (noofchar)
unsigned char	noofchar;
{
char	i,j,k,ch;

	for (i=0; i< HEIGHT; i++)
	{
		for (j=0; j < noofchar*2; j++)
		{
			ch = buffer[i][j];
			k=1;
			if (j==0)
			{
				ch <<= 1;
				k=2;
			}
			for (; k<=8; k++)
			{
				if (ch & 0x80)
					putchar ('#');
				else
					putchar (' ');
				ch <<= 1;
			}
		}
		putchar ('\n');
	}
}

map  (inchar, fontcode, charcode)
char	inchar;
char	*fontcode, *charcode;
{
	*fontcode= 0xA1; *charcode= 0x40;	/* space */
	if (inchar == '\t')
		return (0);
	if (inchar < 0x20)
		return (-1);
	switch (inchar)
	{
	 case 'A': case 'B': case 'C': case 'D':
	 case 'E': case 'F': case 'G': case 'H':
	 case 'I': case 'J': case 'K': case 'L':
	 case 'M': case 'N': case 'O': case 'P':
	 case 'Q': case 'R': case 'S': case 'T':
	 case 'U': case 'V': case 'W': case 'X':
	 case 'Y': case 'Z':
		*fontcode= 0xA2; *charcode= 0xCF+inchar-'A';
		break;
	 case 'a': case 'b': case 'c': case 'd':
	 case 'e': case 'f': case 'g': case 'h':
	 case 'i': case 'j': case 'k': case 'l':
	 case 'm': case 'n': case 'o': case 'p':
	 case 'q': case 'r': case 's': case 't':
	 case 'u': case 'v':
		*fontcode= 0xA2; *charcode= 0xE9+inchar-'a';
		break;
	 case 'w': case 'x': case 'y': case 'z':
		*fontcode= 0xA3; *charcode= 0x40+inchar-'w';
		break;
	 case '0': case '1': case '2': case '3':
	 case '4': case '5': case '6': case '7':
	 case '8': case '9':
		*fontcode= 0xA2; *charcode= 0xAF+inchar-'0';
		break;
	 case ',':
		*fontcode= 0xA1; *charcode= 0x41;
		break;
	 case '.':
		*fontcode= 0xA1; *charcode= 0x44;
		break;
	 case ';':
		*fontcode= 0xA1; *charcode= 0x46;
		break;
	 case ':':
		*fontcode= 0xA1; *charcode= 0x47;
		break;
	 case '?':
		*fontcode= 0xA1; *charcode= 0x48;
		break;
	 case '!':
		*fontcode= 0xA1; *charcode= 0x49;
		break;
	 case '|':
		*fontcode= 0xA1; *charcode= 0x57;
		break;
	 case '(':
		*fontcode= 0xA1; *charcode= 0x5D;
		break;
	 case ')':
		*fontcode= 0xA1; *charcode= 0x5E;
		break;
	 case '{':
		*fontcode= 0xA1; *charcode= 0x61;
		break;
	 case '}':
		*fontcode= 0xA1; *charcode= 0x62;
		break;
	 case '[':
		*fontcode= 0xA1; *charcode= 0x65;
		break;
	 case ']':
		*fontcode= 0xA1; *charcode= 0x66;
		break;
	 case '<':
		*fontcode= 0xA1; *charcode= 0x71;
		break;
	 case '>':
		*fontcode= 0xA1; *charcode= 0x72;
		break;
	 case '\"':
		*fontcode= 0xA1; *charcode= 0xAA;
		break;
	 case '`':
		*fontcode= 0xA1; *charcode= 0xAB;
		break;
	 case '\'':
		*fontcode= 0xA1; *charcode= 0xAC;
		break;
	 case '#':
		*fontcode= 0xA1; *charcode= 0xAD;
		break;
	 case '&':
		*fontcode= 0xA1; *charcode= 0xAE;
		break;
	 case '*':
		*fontcode= 0xA1; *charcode= 0xAF;
		break;
	 case '_':
		*fontcode= 0xA1; *charcode= 0xC4;
		break;
	 case '+':
		*fontcode= 0xA1; *charcode= 0xDE;
		break;
	 case '-':
		*fontcode= 0xA1; *charcode= 0xDF;
		break;
	 case '=':
		*fontcode= 0xA1; *charcode= 0xE2;
		break;
	 case '~':
		*fontcode= 0xA1; *charcode= 0xE3;
		break;
	 case '^':
		*fontcode= 0xA1; *charcode= 0xF4;
		break;
	 case '/':
		*fontcode= 0xA2; *charcode= 0x41;
		break;
	 case '\\':
		*fontcode= 0xA2; *charcode= 0x42;
		break;
	 case '$':
		*fontcode= 0xA2; *charcode= 0x43;
		break;
	 case '%':
		*fontcode= 0xA2; *charcode= 0x48;
		break;
	 case '@':
		*fontcode= 0xA2; *charcode= 0x49;
		break;
	}
	return (0);
}
